'$sim
$regfile = "m8def.dat"
$crystal = 4000000

Config Portb = Output
Config Portc = Input
Config Portd = Output


Config Lcd = 16 * 2
Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5

Cursor Off
Set Portd.7


Dim Vol As Long , Mute_stat As Long , A As Bit , I As Integer , Db As Single
Vol = 0
Mute_stat = 0
A = 0
I = 100

Cls
Vol = 257 * I
Db = 255 - I
Db = Db * 0.5
Db = 31.5 - Db
Lcd "Volume: " ; Db ; " dB"

Do
If Pinc.5 = 1 Then Gosub Mute
If Pinc.4 = 1 Then Gosub Vol_up
If Pinc.3 = 1 Then Gosub Vol_dn
Loop


Mute:
   If A = 0 Then
      Do
         Cls
         Lcd "Mute ON"
         Mute_stat = 0
         Reset Portd.7
         Shiftout Portd.6 , Portd.5 , Mute_stat , 1
         Waitms 500
         Set Portd.7
         Cls
         Waitms 500
      Loop Until Pinc.5 = 1
      A = 1
   Else
      Cls
      Lcd "Mute OFF"
      Mute_stat = I * 257
      Reset Portd.7
      Shiftout Portd.6 , Portd.5 , Mute_stat , 1
      Wait 1
      Set Portd.7

      Cls
      Db = 255 - I
      Db = Db * 0.5
      Db = 31.5 - Db
      Lcd "Volume: " ; Db ; " dB"
      A = 0
   End If
   Return

Vol_up:
   Cls
   If I < 255 Then
      I = I + 1
      Vol = 257 * I
      Db = 255 - i
      Db = Db * 0.5
      Db = 31.5 - Db
      Lcd "Volume: " ; Db ; " dB"
      Reset Portd.7
      Shiftout Portd.6 , Portd.5 , Vol , 1
      Waitms 100
      Set Portd.7

   Else
      Lcd "Max. Volume"
      Wait 1
      Cls
      Lcd "Volume: " ; Db ; " dB"
   End If
   Return

Vol_dn:
   Cls
   If I > 0 Then
      I = I - 1
      Vol = 257 * I
      Db = 255 - i
      Db = Db * 0.5
      Db = 31.5 - Db
      Lcd "Volume: " ; Db ; " dB"
      Reset Portd.7
      Shiftout Portd.6 , Portd.5 , Vol , 1
      Waitms 100
      Set Portd.7

   Else
      Lcd "Min. Volume"
      Wait 1
      Cls
      Lcd "Volume: " ; Db ; " dB"
   End If

   Return


End